// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?
#include <oxstd.h>

// COLUMN NUMBER:			0		1		2		3		4		5		6			7			8		9		10		11		12		 13 			  14 				15
// VARIABLES FROM STATA:	idtrab;	idemp;	year;	tenure;	educ;	age;	logrank;	jobchange;	loc;	ind;	occup;	big;	dsize	 mean females 	  mean educ		  mean age

main()
{
	decl data = loadmat("sample5.mat");

	decl k10 = trunc(rows(data) / 870);  //chose this value to get something like 87-88 files, such that on mpi I use 11 nodes  (in fact 87 files)
	decl i1 = 0;
	while (i1 < k10)
	{
		i1++;
		println(i1);
		
		decl data = loadmat("sample5.mat");

		data = data[(i1-1).*870:i1 .* 870-1][];

		//data = sortbyc(data, 0); // sort by idtrab

		decl i=0, jobchange = <>, pnr = <>, fnr=<>, ten = <>, educ = <>, rank = <>, age = <>, amt = <>, occ = <>, sec = <>, big =<>, dsize  = <>, mfe=<>, med=<>, mag=<>, ong=<>;

// ORDER OF THE VARIABLES IN THE DATA: idtrab idemp year tenure educ age logrank jobchange loc ind occup dsize mean_females mean_educ mean_age

		while (i < rows(data))
		{
			decl hulp = selectifr(data, data[][0] .== data[i][0]); // select based on idtrab
			hulp=sortbyc(hulp,2);  //sort by year
			decl rows_hulp = rows(hulp);
			decl j=0;
			decl hulp1;
			decl pnr1, fnr1;
			while (rows(hulp) > 0)
			{
				if ((j>0) .|| (i.==0))
				{
				hulp1 = selectifr(hulp, hulp[][1] .== hulp[0][1]); //select based on idemp
				hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
				hulp1 = sortbyc(hulp1, 2); // sort by year
				}
				else
				{
				// nieuw:
					if ((data[i][0] .== pnr1) .&& (data[i][1] .== fnr1))
					{
						hulp1 = hulp1|selectifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp1 = sortbyc(hulp1, 2);
					}
					else
					{
						hulp1 = selectifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp1 = sortbyc(hulp1, 2);
					}
				}
			//println(hulp);

// for Denmark the parameter I have to use  is 22, so number of rows from 1980	to 2001

				decl hulp2 	= hulp1[][6]'~-ones(1,22-rows(hulp1)); // logrank
				decl hulp11 = hulp1[][12]'~-ones(1,22-rows(hulp1)); // dsize
				
				decl hulp3 	= selectifr(hulp1[][3], !(hulp1[][7] .== 0)); //3:tenure
				//decl hulp5 	= selectifr(hulp1[][4], !(hulp1[][7] .== 0)); //4:educ
				decl hulp5	= hulp1[0][4]; //4: educ (take initial value  at the start of the spell (the commented exp above was wrong). Similar for some lines below
				//decl hulp6 	= selectifr(hulp1[][5], !(hulp1[][7] .== 0)); //5:age
				decl hulp6	= hulp1[0][5]; //5:age
				decl hulp4 	= selectifr(hulp1[][7], !(hulp1[][7] .== 0)); //7:jobchange
				//decl hulp7 	= selectifr(hulp1[][8], !(hulp1[][7] .== 0)); //8:loc
				decl hulp7 	= hulp1[0][8]; //8:loc
				//decl hulp8 	= selectifr(hulp1[][9], !(hulp1[][7] .== 0)); //9:ind
				decl hulp8 	= hulp1[0][9]; //9:ind
				//decl hulp9 	= selectifr(hulp1[][10], !(hulp1[][7] .== 0));//10:occup
				decl hulp9  = hulp1[0][10];//10:occup
				//decl hulp10	= selectifr(hulp1[][11], !(hulp1[][7] .== 0));//11:big
				decl hulp10 = hulp1[0][11]; //11: big
				//decl hulp12=  selectifr(hulp1[][13],  !(hulp1[][7] .== 0)); //12: mean females
				decl hulp12=  hulp1[0][13]; //12: mean females
			    //decl hulp13=  selectifr(hulp1[][14],  !(hulp1[][7] .== 0)); //13: mean education
				decl hulp13=  hulp1[0][14]; //13: mean education
			   // decl hulp14=  selectifr(hulp1[][15],  !(hulp1[][7] .== 0)); //14: mean age
				decl hulp14=  hulp1[0][15]; //14: mean age
				
				decl hulp15=  selectifr(hulp1[][1],  !(hulp1[][7] .== 0)); //15: firm id
		

				
				pnr1 = hulp1[0][0]; //idtrab
				fnr1 = hulp1[0][1]; //idemp

				if (rows(vec(hulp3)) .> 0)
				{
					if (rows(hulp3) .> 1)
					{
						println("Number of rows for individual job spell:\t", rows(hulp3));
						println("Id-number for individual:\t", hulp[0][0]);
						println(hulp3);
					}
					else
					{
						pnr = pnr|hulp1[0][0];
						fnr=fnr|hulp1[0][1];
						
						rank = rank|hulp2;
						ten = ten|hulp3;
						jobchange = jobchange|hulp4;
						educ = educ|hulp5;
						age = age|hulp6;
						amt = amt|hulp7;
						sec = sec|hulp8;
						occ = occ|hulp9;
						big = big|hulp10;
					
						mfe=mfe|hulp12;
						med=med|hulp13;
						mag=mag|hulp14;

					

						dsize = dsize|hulp11;
						
					}
				}
				j+=rows(hulp1);
				
			}
			
			decl i2 = i;
			i += rows_hulp;					
		}

		decl filestr = sprint("dur_intermed_", i1, ".fmt");
		savemat(filestr, pnr~fnr~ten~jobchange~educ~age~amt~sec~occ~big~mfe~med~mag~dsize~rank);


	}
	
	return 1;
}
