// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?

#include <oxstd.h>
#include "durations9_base_1m_new.ox "

class ModelChild : ModelBase {
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess); 
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}  		  

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];

	Sigma_chi = exp(vP[K+K_firm+K1+2]);
	BerekenData(vP);
	decl xi_0 = 0;


	decl p;

	decl dfloglik1, dfloglik2;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+3);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;

		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi);		
		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		floglik_p += floglik1;

		if (avScore)
		{
			dfloglik_p[][:columns(dfloglik_p)-2] += dfloglik1[][:columns(dfloglik1)-2] .* floglik1;
			dfloglik_p[][columns(dfloglik_p)-1] += dfloglik1[][columns(dfloglik1)-1] .* floglik1 .* Sigma_chi;
		}
	}

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;

	decl adfunc = floglik_p;
	
	adFunc[0] = log(adfunc);
  
	if (avScore)
	{
		decl v = V0;

		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi), avscore1a;
		decl adfunc1, avscore1b, avscore2b, avscore3b, avscore4b;

		avscore1b = dfloglik_p;
  
		decl avscore1 = avscore1b;
		avscore1 = avscore1 ./ adfunc;

		avScore[0] = avscore1;
	}
	
	return 1;
}

main()
{  
	decl adfunc, avscore;
		
	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		

decl vp=zeros(55,1);

	decl avscore1;
	 	
	MaxBFGS(model.FLoglik10, &vp, &adfunc, &avscore, 0);

	
	
	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);	

	delete model;	
	
	return 1;
}
