// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?

#include <oxstd.h>
#include "durations9_base_2mcorr_new.ox "

class ModelChild : ModelBase {
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}	 

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);
	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];
	V1 = vP[K+K_firm+K1+2];
	
	decl Nu = vP[K+K_firm+K1+3];
	decl Delta = vP[K+K_firm+K1+4];
	decl Eta = vP[K+K_firm+K1+5];
	
	Sigma_chi = exp(vP[K+K_firm+K1+6]);

	BerekenData(vP);
	
	decl xi_0 = 0;
	decl x0 = Age[][0]-Educ[][0]-6;
	decl dfloglik1, dfloglik2;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+7);
	decl p;
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
//			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (dteller ./ noemer) .* (noemer .> 0) .* Sigma_chi;
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl exp_p1 = exp(Nu + Delta .* y + Eta .* x0);
		decl p1 = exp_p1 ./ (1+exp_p1);

		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|Sigma_chi;		
		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		v = V1;
		
		vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|Sigma_chi;		
		if (avScore)
			FLoglik2a(vp, &floglik2, &dfloglik2, 0);
		else
			FLoglik2a(vp, &floglik2, 0, 0);		
		

		floglik_p += p1 .* floglik1 + (1 - p1) .* floglik2;

		if (avScore)
		{
			dfloglik1 = dfloglik1[][:columns(dfloglik1)-2]~zeros(N,1)~dfloglik1[][columns(dfloglik1)-1];
			dfloglik2 = dfloglik2[][:columns(dfloglik2)-3]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-2:];

			dfloglik_p[][:columns(dfloglik_p)-5] += p1 .* (dfloglik1[][:columns(dfloglik1)-2] .* floglik1)
							+ (1-p1) .* (dfloglik2[][:columns(dfloglik2)-2] .* floglik2);			  
			dfloglik_p[][columns(dfloglik_p)-4] += (floglik1 - floglik2) .* p1 .* (1-p1);
			dfloglik_p[][columns(dfloglik_p)-3] += (floglik1 - floglik2) .* p1 .* (1-p1) .* y;
			dfloglik_p[][columns(dfloglik_p)-2] += (floglik1 - floglik2) .* p1 .* (1-p1) .* x0;
			dfloglik_p[][columns(dfloglik_p)-1] += (p1 .* (dfloglik1[][columns(dfloglik1)-1] .* floglik1)
							+ (1-p1) .* (dfloglik2[][columns(dfloglik1)-1] .* floglik2)
							+ (floglik1 - floglik2) .* p1 .* (1-p1) .* dy .* Delta) .* Sigma_chi;
		}
	}

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;
		  
	decl adfunc = floglik_p;
	
	adFunc[0] = log(adfunc);
  
	if (avScore)
	{	
		decl avscore1 = dfloglik_p ./ adfunc;		   
		avScore[0] = avscore1;
	}
	
	return 1;
}

class ModelChild1 : ModelBase {
	
	ModelChild1();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild1();
}

ModelChild1::ModelChild1()
{
	ModelBase();
}

ModelChild1::~ModelChild1()
{
	~ModelBase();
}


/* Overloaded function from ModelBase */
ModelChild1::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];
	V1 = vP[K+K_firm+K1+2];
	
	decl Nu = vP[K+K_firm+K1+3];
	decl Delta = vP[K+K_firm+K1+4];
	decl Eta = vP[K+K_firm+K1+5];
	Sigma_chi = exp(vP[K+K_firm+K1+6]);
	BerekenData(vP);
	
	decl xi_0 = 0;
	decl x0 = Age[][0]-Educ[][0]-6;
	
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));
	
	decl p;
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu + Delta .* y + Eta .* x0) ./ (1+exp(Nu + Delta .* y + Eta .* x0));
 	
		decl evey = meanc(p1 .* y .* V0 + (1 - p1) .* y .* V1);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + (1 - p1) .* V1);
		decl ev2 = meanc(p1 .* V0.^2 + (1 - p1) .* V1.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(1-p1);
			decl dv2dv1 = meanc(2 .* (1-p1) .* V1);
			decl dnu = meanc(p1 .* (1-p1) .* (V0-V1));
			decl dv2dnu = meanc(p1 .* (1-p1) .* (V0.^2-V1.^2));
			decl ddelta = meanc(y .* p1 .* (1-p1) .* (V0-V1));
			decl dv2ddelta = meanc(y .* p1 .* (1-p1) .* (V0.^2-V1.^2));
			decl dsigma = meanc(Delta .* p1 .* (1-p1) .* (V0-V1) .* dy) .* Sigma_chi;
			decl dv2dsigma = meanc(Delta .* p1 .* (1-p1) .* (V0.^2-V1.^2) .* dy) .* Sigma_chi;
			decl deta = meanc(x0 .* p1 .* (1-p1) .* (V0-V1));
			decl dv2deta = meanc(x0 .* p1 .* (1-p1) .* (V0.^2-V1.^2));
			
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdnu = dv2dnu - 2 .* ev .* dnu;
			decl dvarvddelta = dv2ddelta - 2 .* ev .* ddelta;
			decl dvarvdeta = dv2deta - 2 .* ev .* deta; 
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc((1-p1) .* y);
			decl deveydnu = meanc(p1 .* (1-p1) .* (V0-V1).*y);
			decl deveyddelta = meanc(p1 .* (1-p1) .* (V0-V1).*y.^2);
			decl deveydeta = meanc(p1 .* (1-p1) .* (V0-V1).*y.* x0);			
			decl deveydsigma = meanc(Delta .* p1 .* (1-p1) .* (V0-V1) .* y .* dy + p1 .* dy .* V0 + (1-p1) .* dy .* V1) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdnu = deveydnu - ey .* dnu ; 
			decl dtellerddelta = deveyddelta - ey .* ddelta ; 
			decl dtellerdeta = deveydeta - ey .* deta; 
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdnu = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu .* vary); 
			decl dnoemerddelta = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta .* vary); 
			decl dnoemerdeta = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta .* vary); 
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu = (dtellerdnu .* noemer_rho - dnoemerdnu .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta = (dtellerddelta .* noemer_rho - dnoemerddelta .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta = (dtellerdeta .* noemer_rho - dnoemerdeta .* teller_rho) ./ (noemer_rho.^2);
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-6)~dvarvdv0~dvarvdv1~dvarvdnu~dvarvddelta~dvarvdeta~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-6)~drhodv0~drhodv1~drhodnu~drhoddelta~drhodeta~drhodsigma;
		}
	}
	
	adFunc[0] = (varv_p ./ P_random);

	if (avScore)
	{
		avScore[0] = dvarv_p ./ P_random;
	}
	
	return 1;
}

class ModelChild2 : ModelBase {
	
	ModelChild2();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild2();
}

ModelChild2::ModelChild2()
{
	ModelBase();
}

ModelChild2::~ModelChild2()
{
	~ModelBase();
}

ModelChild2::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];
	V1 = vP[K+K_firm+K1+2];
	
	decl Nu = vP[K+K_firm+K1+3];
	decl Delta = vP[K+K_firm+K1+4];
	decl Eta = vP[K+K_firm+K1+5];
	Sigma_chi = exp(vP[K+K_firm+K1+6]);
	BerekenData(vP);
		
	decl xi_0 = 0;
	decl x0 = Age[][0]-Educ[][0]-6;
	
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));
	
	decl p;
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu + Delta .* y + Eta .* x0) ./ (1+exp(Nu + Delta .* y + Eta .* x0));
 	
		decl evey = meanc(p1 .* y .* V0 + (1 - p1) .* y .* V1);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + (1 - p1) .* V1);
		decl ev2 = meanc(p1 .* V0.^2 + (1 - p1) .* V1.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(1-p1);
			decl dv2dv1 = meanc(2 .* (1-p1) .* V1);
			decl dnu = meanc(p1 .* (1-p1) .* (V0-V1));
			decl dv2dnu = meanc(p1 .* (1-p1) .* (V0.^2-V1.^2));
			decl ddelta = meanc(y .* p1 .* (1-p1) .* (V0-V1));
			decl dv2ddelta = meanc(y .* p1 .* (1-p1) .* (V0.^2-V1.^2));
			decl dsigma = meanc(Delta .* p1 .* (1-p1) .* (V0-V1) .* dy) .* Sigma_chi;
			decl dv2dsigma = meanc(Delta .* p1 .* (1-p1) .* (V0.^2-V1.^2) .* dy) .* Sigma_chi;
			decl deta = meanc(x0 .* p1 .* (1-p1) .* (V0-V1));
			decl dv2deta = meanc(x0 .* p1 .* (1-p1) .* (V0.^2-V1.^2));
			
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdnu = dv2dnu - 2 .* ev .* dnu;
			decl dvarvddelta = dv2ddelta - 2 .* ev .* ddelta;
			decl dvarvdeta = dv2deta - 2 .* ev .* deta; 
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc((1-p1) .* y);
			decl deveydnu = meanc(p1 .* (1-p1) .* (V0-V1).*y);
			decl deveyddelta = meanc(p1 .* (1-p1) .* (V0-V1).*y.^2);
			decl deveydeta = meanc(p1 .* (1-p1) .* (V0-V1).*y.* x0);			
			decl deveydsigma = meanc(Delta .* p1 .* (1-p1) .* (V0-V1) .* y .* dy + p1 .* dy .* V0 + (1-p1) .* dy .* V1) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdnu = deveydnu - ey .* dnu ; 
			decl dtellerddelta = deveyddelta - ey .* ddelta ; 
			decl dtellerdeta = deveydeta - ey .* deta; 
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdnu = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu .* vary); 
			decl dnoemerddelta = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta .* vary); 
			decl dnoemerdeta = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta .* vary); 
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu = (dtellerdnu .* noemer_rho - dnoemerdnu .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta = (dtellerddelta .* noemer_rho - dnoemerddelta .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta = (dtellerdeta .* noemer_rho - dnoemerdeta .* teller_rho) ./ (noemer_rho.^2);
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-6)~dvarvdv0~dvarvdv1~dvarvdnu~dvarvddelta~dvarvdeta~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-6)~drhodv0~drhodv1~drhodnu~drhoddelta~drhodeta~drhodsigma;
		}
	}
	
	adFunc[0] = (rho_p ./ P_random);

	if (avScore)
	{
		avScore[0] = drho_p ./ P_random;
	}
	
	return 1;
}

main()
{  
	decl adfunc, avscore;

	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		

	decl vp=zeros(59,1);

	decl i;		  	
	  	
	MaxBFGS(model.FLoglik10, &vp, &adfunc, &avscore, 0);


		
	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);
	
	decl model1 = new ModelChild1();

	model1.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model1.myid == 0)
		println(avscore);

	decl model2 = new ModelChild2();

	model2.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model2.myid == 0)
		println(avscore);			

	delete model;	
	delete model1;
	delete model2;
	
	return 1;
}
