// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?

#include <oxstd.h>
#include "durations9_base_3m_new.ox "

class ModelChild : ModelBase {
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess);  
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}  	   

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];
	V1 = vP[K+K_firm+K1+2];
	V2 = vP[K+K_firm+K1+3];

	decl x0 = Age[][0]-Educ[][0]-6;

	decl eta0 = vP[K+K_firm+K1+4]; 
	decl eta1 = vP[K+K_firm+K1+5];
	
	decl delta0 = vP[K+K_firm+K1+6]; 
	decl delta1 = vP[K+K_firm+K1+7]; 


	P1 = exp(eta0 + delta0 .* x0) ./ (1 + exp(eta0 + delta0 .* x0) + exp(eta1 + delta1 .* x0));
	P2 = exp(eta1 + delta1 .* x0) ./ (1 + exp(eta0 + delta0 .* x0) + exp(eta1 + delta1 .* x0));
	decl P3 = 1 - P1 - P2;
	
	Sigma_chi = exp(vP[K+K_firm+K1+8]);

	BerekenData(vP);

	decl xi_0 = 0;
	
	decl p;

	decl dfloglik1, dfloglik2, dfloglik3;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+9);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;

		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi);		
		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		v = V1;
		
		vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi);		
		if (avScore)
			FLoglik2a(vp, &floglik2, &dfloglik2, 0);
		else
			FLoglik2a(vp, &floglik2, 0, 0);

		v = V2;
		
		vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi);		
		if (avScore)
			FLoglik2a(vp, &floglik3, &dfloglik3, 0);
		else
			FLoglik2a(vp, &floglik3, 0, 0);				
		
		floglik_p += P1 .* floglik1 + P2 .* floglik2 + P3 .* floglik3;

		if (avScore)
		{
			dfloglik1 = dfloglik1[][:columns(dfloglik1)-2]~zeros(N,2)~dfloglik1[][columns(dfloglik1)-1];
			dfloglik2 = dfloglik2[][:columns(dfloglik2)-3]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-2]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-1];
			dfloglik3 = dfloglik3[][:columns(dfloglik3)-3]~zeros(N,2)~dfloglik3[][columns(dfloglik3)-2:];
			dfloglik_p[][:columns(dfloglik_p)-6] += P1 .* (dfloglik1[][:columns(dfloglik1)-2] .* floglik1)
							+ P2 .* (dfloglik2[][:columns(dfloglik2)-2] .* floglik2)
								+ P3 .* (dfloglik3[][:columns(dfloglik3)-2] .* floglik3);
			dfloglik_p[][columns(dfloglik_p)-5] += P1 .* (1-P1) .* floglik1 - P1 .* P2 .* floglik2 - P1 .* P3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-4] += -P1 .* P2 .* floglik1 + P2 .* (1-P2) .* floglik2 - P2 .* P3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-3] += (P1 .* (1-P1) .* floglik1 - P1 .* P2 .* floglik2 - P1 .* P3 .* floglik3) .* x0;
			dfloglik_p[][columns(dfloglik_p)-2] += (-P1 .* P2 .* floglik1 + P2 .* (1-P2) .* floglik2 - P2 .* P3 .* floglik3) .* x0;			
			dfloglik_p[][columns(dfloglik_p)-1] += (P1 .* (dfloglik1[][columns(dfloglik1)-1] .* floglik1)
							+ P2 .* (dfloglik2[][columns(dfloglik1)-1] .* floglik2)
							+ P3 .* (dfloglik3[][columns(dfloglik1)-1] .* floglik3)) .* Sigma_chi;
		}
	}

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;


	decl adfunc = floglik_p;
	
	adFunc[0] = log(adfunc);
  
	if (avScore)
	{
		decl v = V0;

		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi), avscore1a;
		decl adfunc1, avscore1b, avscore2b, avscore3b, avscore4b;

		avscore1b = dfloglik_p;													

		decl avscore1 = avscore1b;
		avscore1 = avscore1 ./ adfunc;


		avScore[0] = avscore1;
	}
	
	return 1;
}			  

class ModelChild1 : ModelBase {
	
	ModelChild1();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild1();
}

ModelChild1::ModelChild1()
{
	ModelBase();
}

ModelChild1::~ModelChild1()
{
	~ModelBase();
}


/* Overloaded function from ModelBase */
ModelChild1::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1); 

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];
	V1 = vP[K+K_firm+K1+2];
	V2 = vP[K+K_firm+K1+3];

	decl x0 = Age[][0]-Educ[][0]-6;

	decl eta0 = vP[K+K_firm+K1+4]; 
	decl eta1 = vP[K+K_firm+K1+5];
	
	decl delta0 = vP[K+K_firm+K1+6]; 
	decl delta1 = vP[K+K_firm+K1+7]; 


	P1 = exp(eta0 + delta0 .* x0) ./ (1 + exp(eta0 + delta0 .* x0) + exp(eta1 + delta1 .* x0));
	P2 = exp(eta1 + delta1 .* x0) ./ (1 + exp(eta0 + delta0 .* x0) + exp(eta1 + delta1 .* x0));
	decl P3 = 1 - P1 - P2;
	
	Sigma_chi = exp(vP[K+K_firm+K1+8]);

	decl xi_0 = 0;

	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	
	decl p;

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+12);
	
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;

		decl ev = meanc(P1 .* V0 + P2 .* V1 + P3 .* V2);
		decl ev2 = meanc(P1 .* V0.^2 + P2 .* V1.^2 + P3 .* V2.^2);
		decl varv = ev2 - ev.^2;
							  
		varv_p += varv;
		
		if (avScore)
		{
			decl p1 = P1;
			decl p2 = P2;
			decl p3 = P3;
			
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(p2);
			decl dv2dv1 = meanc(2 .* p2 .* V1);
			decl dv2 = meanc(p3);
			decl dv2dv2 = meanc(2 .* p3 .* V2);
			decl deta1 = meanc(p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2);
			decl dv2deta1 = meanc(p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2);
			decl deta2 = meanc(-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2);
			decl dv2deta2 = meanc(-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2);
			decl ddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* x0);
			decl dv2ddelta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* x0);
			decl ddelta2 =  meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* x0);
			decl dv2ddelta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* x0);
				   
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdv2 = dv2dv2 - 2 .* ev .* dv2;
			decl dvarvdeta1 = dv2deta1 - 2 .* ev .* deta1;
			decl dvarvdeta2 = dv2deta2 - 2 .* ev .* deta2;
			decl dvarvddelta1 = dv2ddelta1 - 2 .* ev .* ddelta1;
			decl dvarvddelta2 = dv2ddelta2 - 2 .* ev .* ddelta2;
			decl dvarvdsigma = 0;

				
			dvarv_p  += zeros(1,rows(vP)-8)~dvarvdv0~dvarvdv1~dvarvdv2~dvarvdeta1~dvarvdeta2~dvarvddelta1~dvarvddelta2
										~dvarvdsigma;
		}
	}
	
	adFunc[0] = (varv_p ./ P_random);

	if (avScore)
	{
		avScore[0] = dvarv_p ./ P_random;
	}
	
	return 1;
}

main()
{  
	decl adfunc, avscore;
		
	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		

		   decl vp=zeros(61,1);
	MaxBFGS(model.FLoglik10, &vp, &adfunc, &avscore, 0);
	
	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);

	decl model1 = new ModelChild1();

	model1.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model1.myid == 0)
		println(avscore);		

	delete model;	
	delete model1;

	return 1;
}
