// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?

#include <oxstd.h>
#include "durations9_base_3mcorr_new.ox "

class ModelChild : ModelBase {
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}	 

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1); 

	Beta = vP[0];
    Beta1 = vP[1];
    Gamma = vP[2:K+1];
    Xi = vP[K+2:K+K_firm+1];
    Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
    V0 = vP[K+K_firm+K1+1];
    V1 = vP[K+K_firm+K1+2];
    V2 = vP[K+K_firm+K1+3];

    decl Nu1 = vP[K+K_firm+K1+4];
    decl Nu2 = vP[K+K_firm+K1+5];
    decl Delta1 = vP[K+K_firm+K1+6];
    decl Delta2 = vP[K+K_firm+K1+7];
    decl Eta1 = vP[K+K_firm+K1+8];
    decl Eta2 = vP[K+K_firm+K1+9];
	
    Sigma_chi = exp(vP[K+K_firm+K1+10]);

	BerekenData(vP);

    decl nu = Nu1|Nu2;
    decl delta = Delta1|Delta2;

 
	decl x0 = Age[][0]-Educ[][0]-6;
	decl xi_0 = 0; 

    decl p;

 

	decl dfloglik1, dfloglik2, dfloglik3;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+11);

	for(p=0;p<P_random;p++)
	{
    	Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;

		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);

                              

		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}

		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));

 

		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|Sigma_chi;                              

		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		v = V1;

		vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|Sigma_chi;                       

        if (avScore)
        	FLoglik2a(vp, &floglik2, &dfloglik2, 0);
		else
			FLoglik2a(vp, &floglik2, 0, 0);

 		v = V2;

		vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|Sigma_chi;                       

        if (avScore)
			FLoglik2a(vp, &floglik3, &dfloglik3, 0);
		else
			FLoglik2a(vp, &floglik3, 0, 0);                                                   

		floglik_p += p1 .* floglik1 + p2 .* floglik2 + p3 .* floglik3;


		if (avScore)
		{
			dfloglik1 = dfloglik1[][:columns(dfloglik1)-2]~zeros(N,2)~dfloglik1[][columns(dfloglik1)-1];
			dfloglik2 = dfloglik2[][:columns(dfloglik2)-3]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-2]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-1];
			dfloglik3 = dfloglik3[][:columns(dfloglik3)-3]~zeros(N,2)~dfloglik3[][columns(dfloglik3)-2:];
            dfloglik_p[][:columns(dfloglik_p)-8] += p1 .* (dfloglik1[][:columns(dfloglik1)-2] .* floglik1)
                                                   + p2 .* (dfloglik2[][:columns(dfloglik2)-2] .* floglik2)
                                                    + p3 .* (dfloglik3[][:columns(dfloglik3)-2] .* floglik3);
			dfloglik_p[][columns(dfloglik_p)-7] += p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-6] += -p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-5] += (p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3) .* y;
			dfloglik_p[][columns(dfloglik_p)-4] += (-p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3) .* y;
			dfloglik_p[][columns(dfloglik_p)-3] += (p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3) .* x0;
			dfloglik_p[][columns(dfloglik_p)-2] += (-p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3) .* x0;			
			
			dfloglik_p[][columns(dfloglik_p)-1] += (p1 .* (dfloglik1[][columns(dfloglik1)-1] .* floglik1)
                                                    + p2 .* (dfloglik2[][columns(dfloglik1)-1] .* floglik2)
                                                    + p3 .* (dfloglik3[][columns(dfloglik1)-1] .* floglik3)
                                               +  (p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* floglik1
                                                 +  (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* floglik2
                                                           - (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* floglik3) .* Sigma_chi;
                               }
                }

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;



	decl adfunc = floglik_p;

               
	adFunc[0] = log(adfunc);

 

	if (avScore)
	{
		decl v = V0;

		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi), avscore1a;
		decl adfunc1, avscore1b, avscore2b, avscore3b, avscore4b;																	

		decl avscore1 = dfloglik_p ./ adfunc;
        avScore[0] = avscore1;

	}

	return 1;
}

class ModelChild1 : ModelBase {
	
	ModelChild1();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild1();
}

ModelChild1::ModelChild1()
{
	ModelBase();
}

ModelChild1::~ModelChild1()
{
	~ModelBase();
}


/* Overloaded function from ModelBase */
ModelChild1::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
    ranseed(-1);
	Beta = vP[0];
    Beta1 = vP[1];
    Gamma = vP[2:K+1];
    Xi = vP[K+2:K+K_firm+1];
    Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
    V0 = vP[K+K_firm+K1+1];
    V1 = vP[K+K_firm+K1+2];
    V2 = vP[K+K_firm+K1+3];

    decl Nu1 = vP[K+K_firm+K1+4];
    decl Nu2 = vP[K+K_firm+K1+5];
    decl Delta1 = vP[K+K_firm+K1+6];
    decl Delta2 = vP[K+K_firm+K1+7];
    decl Eta1 = vP[K+K_firm+K1+8];
    decl Eta2 = vP[K+K_firm+K1+9];	
    Sigma_chi = exp(vP[K+K_firm+K1+10]);

    decl nu = Nu1|Nu2;
    decl delta = Delta1|Delta2;

 
	decl x0 = Age[][0]-Educ[][0]-6;
	decl xi_0 = 0;				 
  	decl p;
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+12);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));

		decl evey = meanc(p1 .* y .* V0 + p2 .* y .* V1 + p3 .* y .* V2);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + p2 .* V1 + p3 .* V2);
		decl ev2 = meanc(p1 .* V0.^2 + p2 .* V1.^2 + p3 .* V2.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;		
	
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(p2);
			decl dv2dv1 = meanc(2 .* p2 .* V1);
			decl dv2 = meanc(p3);
			decl dv2dv2 = meanc(2 .* p3 .* V2);			
			decl dnu1 = meanc(p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2);
			decl dv2dnu1 = meanc(p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2);
			decl dnu2 = meanc(-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2);
			decl dv2dnu2 = meanc(-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2);			
			decl ddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl dv2ddelta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* y);
			decl ddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl dv2ddelta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* y);
			decl deta1 =  meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* x0);
			decl dv2deta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* x0);
			decl deta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* x0);
			decl dv2deta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* x0);			
			decl dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2)) .* Sigma_chi;
			decl dv2dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0.^2
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1.^2
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2.^2)) .* Sigma_chi;
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdv2 = dv2dv2 - 2 .* ev .* dv2;
			decl dvarvdnu1 = dv2dnu1 - 2 .* ev .* dnu1;
			decl dvarvdnu2 = dv2dnu2 - 2 .* ev .* dnu2;
			decl dvarvddelta1 = dv2ddelta1 - 2 .* ev .* ddelta1;
			decl dvarvddelta2 = dv2ddelta2 - 2 .* ev .* ddelta2;
			decl dvarvdeta1 = dv2deta1 - 2 .* ev .* deta1;
			decl dvarvdeta2 = dv2deta2 - 2 .* ev .* deta2;
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc(p2 .* y);
			decl deveydv2 = meanc(p3 .* y);
			decl deveydnu1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl deveydnu2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl deveyddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y.^2);
			decl deveyddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y.^2);
			decl deveydeta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y .* x0);
			decl deveydeta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y .* x0);			
			decl deveydsigma =  meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2) .* y + p1 .* V0 .* dy + p2 .* V1 .* dy + p3 .* V2 .* dy) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdv2 = deveydv2 - ey .* dv2 ; 
			decl dtellerdnu1 = deveydnu1 - ey .* dnu1; 
			decl dtellerdnu2 = deveydnu2 - ey .* dnu2; 
			decl dtellerddelta1 = deveyddelta1 - ey .* ddelta1; 
			decl dtellerddelta2 = deveyddelta2 - ey .* ddelta2;
			decl dtellerdeta1 = deveydeta1 - ey .* deta1; 
			decl dtellerdeta2 = deveydeta2 - ey .* deta2; 			
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdv2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv2 .* vary); 
			decl dnoemerdnu1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu1 .* vary); 
			decl dnoemerdnu2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu2 .* vary); 
			decl dnoemerddelta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta1 .* vary); 
			decl dnoemerddelta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta2 .* vary);
			decl dnoemerdeta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta1 .* vary); 
			decl dnoemerdeta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta2 .* vary); 			
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv2 = (dtellerdv2 .* noemer_rho - dnoemerdv2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu1 = (dtellerdnu1 .* noemer_rho - dnoemerdnu1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu2 = (dtellerdnu2 .* noemer_rho - dnoemerdnu2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta1 = (dtellerddelta1 .* noemer_rho - dnoemerddelta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta2 = (dtellerddelta2 .* noemer_rho - dnoemerddelta2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta1 = (dtellerdeta1 .* noemer_rho - dnoemerdeta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta2 = (dtellerdeta2 .* noemer_rho - dnoemerdeta2 .* teller_rho) ./ (noemer_rho.^2);;
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-10)~dvarvdv0~dvarvdv1~dvarvdv2~dvarvdnu1~dvarvdnu2~dvarvddelta1~dvarvddelta2~dvarvdeta1~dvarvdeta2~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-10)~drhodv0~drhodv1~drhodv2~drhodnu1~drhodnu2~drhoddelta1~drhoddelta2~drhodeta1~drhodeta2~drhodsigma;		
		}
	}

	if (avScore)
	{
		avScore[0] = dvarv_p ./ P_random;
	}	

	adFunc[0] = (varv_p ./ P_random);	 
	
	return 1;
}

class ModelChild2 : ModelBase {
	
	ModelChild2();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild2();
}

ModelChild2::ModelChild2()
{
	ModelBase();
}

ModelChild2::~ModelChild2()
{
	~ModelBase();
}

ModelChild2::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
    ranseed(-1);
	Beta = vP[0];
    Beta1 = vP[1];
    Gamma = vP[2:K+1];
    Xi = vP[K+2:K+K_firm+1];
    Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
    V0 = vP[K+K_firm+K1+1];
    V1 = vP[K+K_firm+K1+2];
    V2 = vP[K+K_firm+K1+3];

    decl Nu1 = vP[K+K_firm+K1+4];
    decl Nu2 = vP[K+K_firm+K1+5];
    decl Delta1 = vP[K+K_firm+K1+6];
    decl Delta2 = vP[K+K_firm+K1+7];
    decl Eta1 = vP[K+K_firm+K1+8];
    decl Eta2 = vP[K+K_firm+K1+9];	
    Sigma_chi = exp(vP[K+K_firm+K1+10]);

    decl nu = Nu1|Nu2;
    decl delta = Delta1|Delta2;

 
	decl x0 = Age[][0]-Educ[][0]-6;
	decl xi_0 = 0;				 
  	decl p;
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+12);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));

		decl evey = meanc(p1 .* y .* V0 + p2 .* y .* V1 + p3 .* y .* V2);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + p2 .* V1 + p3 .* V2);
		decl ev2 = meanc(p1 .* V0.^2 + p2 .* V1.^2 + p3 .* V2.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;		
	
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(p2);
			decl dv2dv1 = meanc(2 .* p2 .* V1);
			decl dv2 = meanc(p3);
			decl dv2dv2 = meanc(2 .* p3 .* V2);			
			decl dnu1 = meanc(p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2);
			decl dv2dnu1 = meanc(p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2);
			decl dnu2 = meanc(-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2);
			decl dv2dnu2 = meanc(-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2);			
			decl ddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl dv2ddelta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* y);
			decl ddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl dv2ddelta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* y);
			decl deta1 =  meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* x0);
			decl dv2deta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* x0);
			decl deta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* x0);
			decl dv2deta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* x0);			
			decl dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2)) .* Sigma_chi;
			decl dv2dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0.^2
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1.^2
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2.^2)) .* Sigma_chi;
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdv2 = dv2dv2 - 2 .* ev .* dv2;
			decl dvarvdnu1 = dv2dnu1 - 2 .* ev .* dnu1;
			decl dvarvdnu2 = dv2dnu2 - 2 .* ev .* dnu2;
			decl dvarvddelta1 = dv2ddelta1 - 2 .* ev .* ddelta1;
			decl dvarvddelta2 = dv2ddelta2 - 2 .* ev .* ddelta2;
			decl dvarvdeta1 = dv2deta1 - 2 .* ev .* deta1;
			decl dvarvdeta2 = dv2deta2 - 2 .* ev .* deta2;
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc(p2 .* y);
			decl deveydv2 = meanc(p3 .* y);
			decl deveydnu1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl deveydnu2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl deveyddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y.^2);
			decl deveyddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y.^2);
			decl deveydeta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y .* x0);
			decl deveydeta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y .* x0);			
			decl deveydsigma =  meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2) .* y + p1 .* V0 .* dy + p2 .* V1 .* dy + p3 .* V2 .* dy) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdv2 = deveydv2 - ey .* dv2 ; 
			decl dtellerdnu1 = deveydnu1 - ey .* dnu1; 
			decl dtellerdnu2 = deveydnu2 - ey .* dnu2; 
			decl dtellerddelta1 = deveyddelta1 - ey .* ddelta1; 
			decl dtellerddelta2 = deveyddelta2 - ey .* ddelta2;
			decl dtellerdeta1 = deveydeta1 - ey .* deta1; 
			decl dtellerdeta2 = deveydeta2 - ey .* deta2; 			
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdv2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv2 .* vary); 
			decl dnoemerdnu1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu1 .* vary); 
			decl dnoemerdnu2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu2 .* vary); 
			decl dnoemerddelta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta1 .* vary); 
			decl dnoemerddelta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta2 .* vary);
			decl dnoemerdeta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta1 .* vary); 
			decl dnoemerdeta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta2 .* vary); 			
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv2 = (dtellerdv2 .* noemer_rho - dnoemerdv2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu1 = (dtellerdnu1 .* noemer_rho - dnoemerdnu1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu2 = (dtellerdnu2 .* noemer_rho - dnoemerdnu2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta1 = (dtellerddelta1 .* noemer_rho - dnoemerddelta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta2 = (dtellerddelta2 .* noemer_rho - dnoemerddelta2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta1 = (dtellerdeta1 .* noemer_rho - dnoemerdeta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta2 = (dtellerdeta2 .* noemer_rho - dnoemerdeta2 .* teller_rho) ./ (noemer_rho.^2);;
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-10)~dvarvdv0~dvarvdv1~dvarvdv2~dvarvdnu1~dvarvdnu2~dvarvddelta1~dvarvddelta2~dvarvdeta1~dvarvdeta2~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-10)~drhodv0~drhodv1~drhodv2~drhodnu1~drhodnu2~drhoddelta1~drhoddelta2~drhodeta1~drhodeta2~drhodsigma;		
		}
	}

	if (avScore)
	{
		avScore[0] = drho_p ./ P_random;
	}	

	adFunc[0] = (rho_p ./ P_random);	 
	
	return 1;
}

main()
{  
	decl adfunc, avscore;

	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		
	decl vp=zeros(63,1);
		
	MaxBFGS(model.FLoglik10, &vp, &adfunc, &avscore, 0);
	
	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);
	
	decl model1 = new ModelChild1();

	model1.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model1.myid == 0)
		println(avscore);

	decl model2 = new ModelChild2();

	model2.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model2.myid == 0)
		println(avscore);			

	delete model;	
	delete model1;
	delete model2;
	
	return 1;
}
