// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?
#include <oxstd.h>

// COLUMN NUMBER:			0		1		2		3		4		5		6			7			8		9		10		11		12		13				14			15			
// VARIABLES FROM STATA:	idtrab;	idemp;	year;	tenure;	educ;	age;	logrank;	jobchange;	loc;	ind;	occup;	big;	dsize;	mean_female;	mean_educ;	mean_age;	

main()
{
	decl data = loadmat("durations.mat");

	decl k10 = trunc(rows(data) / 1022);
		println(k10);

	decl i1 = 0;
	while (i1 < k10)
	{
		i1++;
		println(i1);
		
		decl data = loadmat("durations.mat");
		
		data = data[(i1-1).*1022:i1 .* 1022-1][];

		decl i=0, jobchange = <>, pnr = <>, fnr = <>, ten = <>, educ = <>, rank = <>, age = <>, amt = <>, occ = <>, sec = <>, big =<>, dsize  = <>, mfe =<>, med =<>, mag =<>;

// ORDER OF THE VARIABLES IN THE DATA: idtrab idemp year tenure educ age logrank jobchange loc ind occup dsize

		while (i < rows(data))
		{
			decl hulp = selectifr(data, data[][0] .== data[i][0]); // select based on idtrab
			hulp = sortbyc(hulp, 2);
			decl hulp1;
			decl rows_hulp = rows(hulp);
			decl pnr1, fnr1;
			while (rows(hulp) > 0)
			{
				if ((i.==0))
				{
				hulp1 = selectifr(hulp, hulp[][1] .== hulp[0][1]); //select based on idemp
				hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
				hulp1 = sortbyc(hulp1, 2); // sort by year
				}
				else
				{
					if ((hulp[][0] .== pnr1) .&& (hulp[][1] .== fnr1))
					{
						hulp1 = hulp1|selectifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp1 = sortbyc(hulp1, 2);
					}
					else
					{
						hulp1 = selectifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp = deleteifr(hulp, hulp[][1] .== hulp[0][1]);
						hulp1 = sortbyc(hulp1, 2);
					}
				}
				decl hulp2 	= hulp1[][6]'~-ones(1,23-rows(hulp1)); // logrank
				decl hulp11 = hulp1[][12]'~-ones(1,23-rows(hulp1)); // dsize

				decl hulp3 	= selectifr(hulp1[][3], !(hulp1[][7] .== 0)); //3:tenure
				decl hulp5 	= hulp1[0][4]; //4:educ
				decl hulp6 	= hulp1[0][5]; //5:age
				decl hulp4 	= selectifr(hulp1[][7], !(hulp1[][7] .== 0)); //7:jobchange
				decl hulp7 	= hulp1[0][8]; //8:loc
				decl hulp8 	= hulp1[0][9]; //9:ind
				decl hulp9 	= hulp1[0][10];//10:occup
				decl hulp10	= hulp1[0][11];//11:big
				decl hulp12	= hulp1[0][13];//12:mean_female
				decl hulp13	= hulp1[0][14];//13:mean_educ
				decl hulp14	= hulp1[0][15];//14:mean_age

				decl hulp15	= selectifr(hulp1[][1], !(hulp1[][7] .== 0));//15:firm id

				
				pnr1 = hulp1[0][0]; //idtrab
				fnr1 = hulp1[0][1]; //idemp

				if (rows(vec(hulp3)) .> 0)
				{
					if (rows(hulp3) .> 1)
					{
						println("Number of rows for individual job spell:\t", rows(hulp3));
						println("Id-number for individual:\t", hulp1[0][0]);
						println(hulp3~hulp7);
						println(hulp1);
						exit(-1);
					}
					else
					{
						pnr = pnr|hulp1[0][0];
						fnr = fnr|hulp1[0][1];

						rank = rank|hulp2;
						ten = ten|hulp3;
						jobchange = jobchange|hulp4;
						educ = educ|hulp5;
						age = age|hulp6;
						amt = amt|hulp7;
						sec = sec|hulp8;
						occ = occ|hulp9;
						big = big|hulp10;
						mfe = mfe|hulp12;
						med = med|hulp13;
						mag = mag|hulp14;
						dsize = dsize|hulp11;

						}
				}
			}
			
			decl i2 = i;
			i += rows_hulp;					
		}

		decl filestr = sprint("dur_intermed_", i1, ".fmt");
		savemat(filestr, pnr~fnr~ten~jobchange~educ~age~amt~sec~occ~big~mfe~med~mag~dsize~rank);
	}
	return 1;
}
