// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?
#include <oxstd.h>
#include "durations9_base_1m.ox "

class ModelChild : ModelBase {
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess); 
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}  		  

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Gamma = vP[2:K+1];
	Xi = vP[K+2:K+K_firm+1];
	Psi = 0|vP[K+K_firm+2:K+K_firm+K1];
	V0 = vP[K+K_firm+K1+1];

	Sigma_chi = exp(vP[K+K_firm+K1+2]);
	BerekenData(vP);
	decl xi_0 = 0;


	decl p;

	decl dfloglik1, dfloglik2;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+3);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;

		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi);		
		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		floglik_p += floglik1;

		if (avScore)
		{
			dfloglik_p[][:columns(dfloglik_p)-2] += dfloglik1[][:columns(dfloglik1)-2] .* floglik1;
			dfloglik_p[][columns(dfloglik_p)-1] += dfloglik1[][columns(dfloglik1)-1] .* floglik1 .* Sigma_chi;
		}
	}

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;

	decl adfunc = floglik_p;
	
	adFunc[0] = log(adfunc);
  
	if (avScore)
	{
		decl v = V0;

		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi), avscore1a;
		decl adfunc1, avscore1b, avscore2b, avscore3b, avscore4b;

		avscore1b = dfloglik_p;
  
		decl avscore1 = avscore1b;
		avscore1 = avscore1 ./ adfunc;

		avScore[0] = avscore1;
	}
	
	return 1;
}

main()
{  
	decl adfunc, avscore;
		
	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		
decl vp = 	-0.16362 |   0.0071697  |  -0.060537  |   -0.11361   |   0.41304  |   -0.28460	  |
     		-0.81708 |    -0.30009  |   -0.34739  |   -0.41134   |  -0.13376  |   -0.49529	  |
     		-0.73631 |     0.44801  |    0.16425  |    0.13960   |   0.37282  |    0.27015	  |
      		0.56343  |   0.083262   |  -0.48217   | 0.0099845    |  0.32855   |  -0.12195	  |
    		-0.043832|    -0.095610 |    -0.38233 |    -0.56320  |   -0.75129 |    -0.98605	  |
      		-1.1010  |    -1.2806   |   -1.1264   |   -1.4993    |  -1.3582   |   -1.6805	  |
      		-1.5047  |    -1.8788   |   -1.4553   |   -1.6778    |  -1.3682   |   -4.6354	  |
      		-2.4440  |    -1.8833   |   -2.6445   |   -1.4673    | -0.63421   |    1.6628	  |
      		-7.0380;

	decl avscore1;
	 	
	MaxBFGS(model.FLoglik10, &vp, &adfunc, &avscore, 0);

	
	
	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);	

	delete model;	
	
	return 1;
}
