// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?
#include <oxstd.h>
#include "durations9_base_3mcorr_squared.ox "

class ModelChild : ModelBase {
	decl Beta2, Beta3, X2, NSize2;
	
	ModelChild();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	FLoglik1a(const vP, const adFunc, const avScore, const mHess);
	FLoglik2a(const vP, const adFunc, const avScore, const mHess);
	BerekenData(const vP);
	BerekenData1a(const vP);
	~ModelChild();
}

ModelChild::ModelChild()
{
	ModelBase();
}

ModelChild::~ModelChild()
{
	~ModelBase();
}	 

/* Overloaded function from ModelBase */
ModelChild::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
	ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Beta2 = vP[2];
	Beta3 = vP[3];
	Gamma = vP[4:K+3];
	Xi = vP[K+4:K+K_firm+3];
	Psi = 0|vP[K+K_firm+4:K+K_firm+K1+2];
	V0 = vP[K+K_firm+K1+3];
	V1 = vP[K+K_firm+K1+4];
	V2 = vP[K+K_firm+K1+5];

	decl Nu1 = vP[K+K_firm+K1+6];
	decl Nu2 = vP[K+K_firm+K1+7];
	decl Delta1 = vP[K+K_firm+K1+8];
	decl Delta2 = vP[K+K_firm+K1+9];
	decl Eta1 = vP[K+K_firm+K1+10];
	decl Eta2 = vP[K+K_firm+K1+11];
	Sigma_chi = exp(vP[K+K_firm+K1+12]);

	decl nu = Nu1|Nu2;
	decl delta = Delta1|Delta2;

	
	BerekenData(vP);
	decl xi_0 = 0;
	decl x0 = Age[][0]-Educ[][0]-6;
			
	decl p;

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+13);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));


		decl v = V0, floglik1, floglik2, floglik3, floglik4;
		decl vp = Beta|Beta1|Beta2|Beta3|Gamma|Xi|Psi[1:]|v|Sigma_chi;		
		if (avScore)
			FLoglik2a(vp, &floglik1, &dfloglik1, 0);
		else
			FLoglik2a(vp, &floglik1, 0, 0);

		v = V1;
		
		vp = Beta|Beta1|Beta2|Beta3|Gamma|Xi|Psi[1:]|v|Sigma_chi;		
		if (avScore)
			FLoglik2a(vp, &floglik2, &dfloglik2, 0);
		else
			FLoglik2a(vp, &floglik2, 0, 0);

		v = V2;
		
		vp = Beta|Beta1|Beta2|Beta3|Gamma|Xi|Psi[1:]|v|Sigma_chi;		
		if (avScore)
			FLoglik2a(vp, &floglik3, &dfloglik3, 0);
		else
			FLoglik2a(vp, &floglik3, 0, 0);
		
		
		floglik_p += p1 .* floglik1 + p2 .* floglik2 + p3 .* floglik3;

		if (avScore)
		{
			dfloglik1 = dfloglik1[][:columns(dfloglik1)-2]~zeros(N,2)~dfloglik1[][columns(dfloglik1)-1];
			dfloglik2 = dfloglik2[][:columns(dfloglik2)-3]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-2]~zeros(N,1)~dfloglik2[][columns(dfloglik2)-1];
			dfloglik3 = dfloglik3[][:columns(dfloglik3)-3]~zeros(N,2)~dfloglik3[][columns(dfloglik3)-2:];
            dfloglik_p[][:columns(dfloglik_p)-8] += p1 .* (dfloglik1[][:columns(dfloglik1)-2] .* floglik1)
                                                   + p2 .* (dfloglik2[][:columns(dfloglik2)-2] .* floglik2)
                                                    + p3 .* (dfloglik3[][:columns(dfloglik3)-2] .* floglik3);
			dfloglik_p[][columns(dfloglik_p)-7] += p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-6] += -p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3;
			dfloglik_p[][columns(dfloglik_p)-5] += (p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3) .* y;
			dfloglik_p[][columns(dfloglik_p)-4] += (-p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3) .* y;
			dfloglik_p[][columns(dfloglik_p)-3] += (p1 .* (1-p1) .* floglik1 - p1 .* p2 .* floglik2 - p1 .* p3 .* floglik3) .* x0;
			dfloglik_p[][columns(dfloglik_p)-2] += (-p1 .* p2 .* floglik1 + p2 .* (1-p2) .* floglik2 - p2 .* p3 .* floglik3) .* x0;			
			
			dfloglik_p[][columns(dfloglik_p)-1] += (p1 .* (dfloglik1[][columns(dfloglik1)-1] .* floglik1)
                                                    + p2 .* (dfloglik2[][columns(dfloglik1)-1] .* floglik2)
                                                    + p3 .* (dfloglik3[][columns(dfloglik1)-1] .* floglik3)
                                               +  (p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* floglik1
                                                 +  (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* floglik2
                                                           - (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* floglik3) .* Sigma_chi;
          }
	}

	floglik_p = floglik_p ./ P_random;

	if (avScore)
		dfloglik_p = dfloglik_p / P_random;
		
	decl adfunc = floglik_p;
	
	adFunc[0] = log(adfunc);
  
	if (avScore)
	{
		decl v = V0;

		decl vp = Beta|Beta1|Gamma|Xi|Psi[1:]|v|log(Sigma_chi), avscore1a;
		decl adfunc1, avscore1b, avscore2b, avscore3b, avscore4b;
				
		avscore1b = dfloglik_p;	   
		decl avscore1 = avscore1b;
		avscore1 = avscore1 ./ adfunc;	  

		avScore[0] = avscore1;
	}
	
	return 1;
}

ModelChild::BerekenData1a(const vP)
{
	Psi = 0|vP[K+K_firm+4:K+K_firm+K1+2];
	decl v = vP[K+K_firm+K1+3];

	decl i, hulp10 = <>, hulp12 = <>, hulp13 = <>, hulp100 = <>;
	decl x1 = X~-ones(rows(X),1);
	decl nsize = NSize~-ones(rows(NSize),1);
	decl x1_2 = X2~-ones(rows(X),1);
	decl nsize_2 = NSize2~-ones(rows(NSize),1);	
	decl psi10 = Psi|ones(K1-rows(Psi),1) .* Psi[rows(Psi)-1];
	decl n1 = rows(T);
	decl x1a = Y * Gamma;
	decl x1a_b = Y_Firm * Xi;

	decl x1b = X * Beta .* (!(X .== -1));
	decl x1c = NSize * Beta1 .* (!(NSize .== -1));
	decl x1d = X2 * Beta2 .* (!(X .== -1));
	decl x1e = NSize2 * Beta3 .* (!(NSize .== -1));	
	decl t1 = sumr(!(X .== -1));
	
	decl x0 = new Data_hulp(exp(x1a + x1a_b + x1b + x1c + x1d + x1e + psi10'), X, NSize, Y, Y_Firm, D);
	return x0;
}

ModelChild::BerekenData(const vP){
	
	decl i;
	Hulp_0 = {};
	
	for(i=0;i<K2;i++)
	{
		decl hulp2;
		HandleData1(i, &hulp2);
		X2 = selectifr(X1[][i .*K1:K1 .* (i+1) -1].^2, T1[][i] .>= 0);	
		NSize2 = selectifr(NSize1[][i .*K1:K1 .* (i+1) -1].^2, T1[][i] .>= 0);
		

		decl hulp, dhulp;

		Hulp_0 = Hulp_0|BerekenData1a(vP);
	}

	return 1;
}

ModelChild::FLoglik2a(const vP, const adFunc, const avScore, const mHess)
{
	decl floglik = ones(N,1), dfloglik = zeros(N,rows(vP)), i;

			
	for(i=0;i<K2;i++)
	{
		decl hulp2;
		decl dchi = HandleData(i, &hulp2);
				X2 = selectifr(X1[][i .*K1:K1 .* (i+1) -1].^2, T1[][i] .>= 0);	
		NSize2 = selectifr(NSize1[][i .*K1:K1 .* (i+1) -1].^2, T1[][i] .>= 0);

		decl hulp, dhulp;

		if (rows(X) .> 0)
			FLoglik1a(vP, &hulp, 0, 0);
		else
			hulp = <>;
			
		if (avScore)
		{
			if (rows(X) .> 0)
			{
				FLoglik1a(vP, &hulp, &dhulp, 0);
			}
			else
			{
				hulp = <>;
				dhulp = <>;
			}
		}

		decl avscore, avscore1;
					  
		hulp = hulp|ones(N-rows(hulp),1);
	
		if (avScore)
		{				   				
			dchi = dchi|zeros(N-rows(vec(dchi)),1);
			dhulp = dhulp|zeros(N-rows(dhulp),rows(vP));
		}
		
		floglik = floglik .* hulp;

		if (avScore)
		{		
			dhulp[][columns(dhulp)-1] = dhulp[][columns(dhulp)-1] .* dchi;
			dfloglik = dfloglik + dhulp;
		}
	}

	adFunc[0] = floglik;

	if (avScore)
	{
		avScore[0] = dfloglik;
	}

	return 1;
}


ModelChild::FLoglik1a(const vP, const adFunc, const avScore, const mHess)
{
	decl v = vP[K+K_firm+K1+3];
	
	decl n1 = rows(X);
	decl t1 = sumr(!(X .== -1));
	
	decl exp_hul0 = X_hulp_0.Get_X0() .* exp(v+Chi);
	decl theta0 = exp_hul0 ./ (1 + exp_hul0);
	theta0 = theta0 .* !(X.==-1);
	decl theta1 = 1 - theta0;

	decl hulp6 = prodc((theta1)')';
	decl hulp2 = hulp6 .* diagonal(exp_hul0[][t1-1])';
	

	decl floglik4 = hulp2 .* (1-D) + D .* hulp6;

	adFunc[0] = floglik4;
	
	if (avScore)
	{
		decl dtheta0_1 = theta1 .* theta0;
		decl dtheta1_1 = theta1;		
		decl dhulp1 = -sumc(theta0')';
		decl dhulp2 = dhulp1 + 1;

		decl dx1b = X .* (!(X .== -1));
		decl dx1c = NSize .* (!(NSize .== -1));
		decl dx1d = X2 .* (!(X2 .== -1));
		decl dx1e = NSize2 .* (!(NSize2 .== -1));

		decl dhulp3 = theta0 .* dx1b;		
		decl dhulp3_a = theta0 .* dx1c;
		decl dhulp3_b = theta0 .* dx1d;		
		decl dhulp3_c = theta0 .* dx1e;
		decl dhulp4 = -sumc(dhulp3')';		
		decl dhulp4a = -sumc(dhulp3_a')';
		decl dhulp4b = -sumc(dhulp3_b')';		
		decl dhulp4c = -sumc(dhulp3_c')';		
	
		decl dhulp5 = dhulp4 + diagonal(dx1b[][t1-1])';
		decl dhulp5a =dhulp4a +  diagonal(dx1c[][t1-1])';
		decl dhulp5b = dhulp4b + diagonal(dx1d[][t1-1])';
		decl dhulp5c =dhulp4c +  diagonal(dx1e[][t1-1])';		

		decl avscore4 = (dhulp2 .* (1-D) + D .* dhulp1);
		decl avscore1 = (dhulp5 .* (1-D) + dhulp4 .* D);
		decl avscore1a = (dhulp5a .* (1-D) + dhulp4a .* D);
		decl avscore1b = (dhulp5b .* (1-D) + dhulp4b .* D);
		decl avscore1c = (dhulp5c .* (1-D) + dhulp4c .* D);
		decl avscore2 = avscore4  .* Y;
		decl avscore2a = avscore4  .* Y_Firm;
		decl dhulp15 = -theta0 .* (t1 .>= range(1,K1,1) .* ones(n1,K1));
		decl dhulp14 = dhulp15 + (t1 .== range(1,K1,1));
		decl avscore3 = (dhulp14 .* (1-D) + D .* dhulp15);		
		
	 
		decl avScore_0 =  (avscore1~avscore1a~avscore1b~avscore1c~avscore2~avscore2a~avscore3[][1:K1-1]~avscore4~avscore4);
		
		avScore[0] = avScore_0;
	}  

	return 1;
}

class ModelChild1 : ModelBase {
	decl Beta2, Beta3, X2, NSize2;	
	ModelChild1();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild1();
}

ModelChild1::ModelChild1()
{
	ModelBase();
}

ModelChild1::~ModelChild1()
{
	~ModelBase();
}

	

ModelChild1::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
    ranseed(-1);

	Beta = vP[0];
	Beta1 = vP[1];
	Beta2 = vP[2];
	Beta3 = vP[3];
	Gamma = vP[4:K+3];
	Xi = vP[K+4:K+K_firm+3];
	Psi = 0|vP[K+K_firm+4:K+K_firm+K1+2];
	V0 = vP[K+K_firm+K1+3];
	V1 = vP[K+K_firm+K1+4];
	V2 = vP[K+K_firm+K1+5];

	decl Nu1 = vP[K+K_firm+K1+6];
	decl Nu2 = vP[K+K_firm+K1+7];
	decl Delta1 = vP[K+K_firm+K1+8];
	decl Delta2 = vP[K+K_firm+K1+9];
	decl Eta1 = vP[K+K_firm+K1+10];
	decl Eta2 = vP[K+K_firm+K1+11];
	Sigma_chi = exp(vP[K+K_firm+K1+12]);

	decl nu = Nu1|Nu2;
	decl delta = Delta1|Delta2;

	
	BerekenData(vP);
	
	decl x0 = Age[][0]-Educ[][0]-6;
	decl xi_0 = 0;				 
  	decl p;
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+12);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));

		decl evey = meanc(p1 .* y .* V0 + p2 .* y .* V1 + p3 .* y .* V2);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + p2 .* V1 + p3 .* V2);
		decl ev2 = meanc(p1 .* V0.^2 + p2 .* V1.^2 + p3 .* V2.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;		
	
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(p2);
			decl dv2dv1 = meanc(2 .* p2 .* V1);
			decl dv2 = meanc(p3);
			decl dv2dv2 = meanc(2 .* p3 .* V2);			
			decl dnu1 = meanc(p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2);
			decl dv2dnu1 = meanc(p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2);
			decl dnu2 = meanc(-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2);
			decl dv2dnu2 = meanc(-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2);			
			decl ddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl dv2ddelta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* y);
			decl ddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl dv2ddelta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* y);
			decl deta1 =  meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* x0);
			decl dv2deta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* x0);
			decl deta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* x0);
			decl dv2deta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* x0);			
			decl dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2)) .* Sigma_chi;
			decl dv2dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0.^2
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1.^2
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2.^2)) .* Sigma_chi;
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdv2 = dv2dv2 - 2 .* ev .* dv2;
			decl dvarvdnu1 = dv2dnu1 - 2 .* ev .* dnu1;
			decl dvarvdnu2 = dv2dnu2 - 2 .* ev .* dnu2;
			decl dvarvddelta1 = dv2ddelta1 - 2 .* ev .* ddelta1;
			decl dvarvddelta2 = dv2ddelta2 - 2 .* ev .* ddelta2;
			decl dvarvdeta1 = dv2deta1 - 2 .* ev .* deta1;
			decl dvarvdeta2 = dv2deta2 - 2 .* ev .* deta2;
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc(p2 .* y);
			decl deveydv2 = meanc(p3 .* y);
			decl deveydnu1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl deveydnu2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl deveyddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y.^2);
			decl deveyddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y.^2);
			decl deveydeta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y .* x0);
			decl deveydeta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y .* x0);			
			decl deveydsigma =  meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2) .* y + p1 .* V0 .* dy + p2 .* V1 .* dy + p3 .* V2 .* dy) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdv2 = deveydv2 - ey .* dv2 ; 
			decl dtellerdnu1 = deveydnu1 - ey .* dnu1; 
			decl dtellerdnu2 = deveydnu2 - ey .* dnu2; 
			decl dtellerddelta1 = deveyddelta1 - ey .* ddelta1; 
			decl dtellerddelta2 = deveyddelta2 - ey .* ddelta2;
			decl dtellerdeta1 = deveydeta1 - ey .* deta1; 
			decl dtellerdeta2 = deveydeta2 - ey .* deta2; 			
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdv2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv2 .* vary); 
			decl dnoemerdnu1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu1 .* vary); 
			decl dnoemerdnu2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu2 .* vary); 
			decl dnoemerddelta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta1 .* vary); 
			decl dnoemerddelta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta2 .* vary);
			decl dnoemerdeta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta1 .* vary); 
			decl dnoemerdeta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta2 .* vary); 			
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv2 = (dtellerdv2 .* noemer_rho - dnoemerdv2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu1 = (dtellerdnu1 .* noemer_rho - dnoemerdnu1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu2 = (dtellerdnu2 .* noemer_rho - dnoemerdnu2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta1 = (dtellerddelta1 .* noemer_rho - dnoemerddelta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta2 = (dtellerddelta2 .* noemer_rho - dnoemerddelta2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta1 = (dtellerdeta1 .* noemer_rho - dnoemerdeta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta2 = (dtellerdeta2 .* noemer_rho - dnoemerdeta2 .* teller_rho) ./ (noemer_rho.^2);;
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-10)~dvarvdv0~dvarvdv1~dvarvdv2~dvarvdnu1~dvarvdnu2~dvarvddelta1~dvarvddelta2~dvarvdeta1~dvarvdeta2~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-10)~drhodv0~drhodv1~drhodv2~drhodnu1~drhodnu2~drhoddelta1~drhoddelta2~drhodeta1~drhodeta2~drhodsigma;		
		}
	}

	if (avScore)
	{
		avScore[0] = dvarv_p ./ P_random;
	}	

	adFunc[0] = (varv_p ./ P_random);	 
	
	return 1;
}

class ModelChild2 : ModelBase {
	decl Beta2, Beta3, X2, NSize2;
		
	ModelChild2();
	FLoglik(const vp, const adfunc, const avscore, const mhess);
	~ModelChild2();
}

ModelChild2::ModelChild2()
{
	ModelBase();
}

ModelChild2::~ModelChild2()
{
	~ModelBase();
}

ModelChild2::FLoglik(const vP, const adFunc, const avScore, const mHess)
{
    ranseed(-1);
	Beta = vP[0];
	Beta1 = vP[1];
	Beta2 = vP[2];
	Beta3 = vP[3];
	Gamma = vP[4:K+3];
	Xi = vP[K+4:K+K_firm+3];
	Psi = 0|vP[K+K_firm+4:K+K_firm+K1+2];
	V0 = vP[K+K_firm+K1+3];
	V1 = vP[K+K_firm+K1+4];
	V2 = vP[K+K_firm+K1+5];

	decl Nu1 = vP[K+K_firm+K1+6];
	decl Nu2 = vP[K+K_firm+K1+7];
	decl Delta1 = vP[K+K_firm+K1+8];
	decl Delta2 = vP[K+K_firm+K1+9];
	decl Eta1 = vP[K+K_firm+K1+10];
	decl Eta2 = vP[K+K_firm+K1+11];
	Sigma_chi = exp(vP[K+K_firm+K1+12]);

	decl nu = Nu1|Nu2;
	decl delta = Delta1|Delta2;

	
	BerekenData(vP);
	
		
	decl x0 = Age[][0]-Educ[][0]-6;
	decl xi_0 = 0;				 
  	decl p;
	decl rho_p = 0;
	decl varv_p = 0;
	decl dvarv_p = zeros(1,rows(vP));
	decl drho_p = zeros(1,rows(vP));

	decl dfloglik1, dfloglik2, dfloglik3, dfloglik4;
	decl floglik_p = zeros(N,1);
	decl dfloglik_p = zeros(N,K+K_firm+K1+12);
	for(p=0;p<P_random;p++)
	{
		Ran_hulp = rann(n_firms,1);
		decl chi1 =  Ran_hulp .* Sigma_chi;
		Chi1 = chi1;
		decl i;
		decl teller = zeros(N,1);
		decl dteller = zeros(N,1);
		decl noemer = zeros(N,1);
		
		for(i=0;i<K2;i++)
		{
			decl firm = Firm[][i];
			decl x1 = X1[][i .*K1:K1 .* (i+1) -1];
			decl t1 = sumr(!(x1 .== -1));
			teller += (Chi1[(firm-1) .* (firm .> 0)] .* t1) .* (t1 .> 0);
			dteller += (Ran_hulp[(firm -1).* (firm .> 0)] .* t1) .* (t1 .> 0);
			noemer += (t1) .* (t1 .> 0);
		}
		decl y = (teller ./ noemer) .* (noemer .> 0);
		y = deleter(y);
		y  = y|zeros(N-rows(y),1);
		decl dy = (dteller ./ noemer) .* (noemer .> 0);
		dy = deleter(dy);
		dy  = dy|zeros(N-rows(dy),1);
		decl p1 = exp(Nu1 + Delta1 .* y + Eta1 .* x0) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));
		decl p2 = exp(Nu2 + Delta2 .* y + Eta2 .* x0 ) ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 * x0));
		decl p3 = 1 ./ (1+ exp(Nu1 + Delta1 .* y + Eta1 .* x0) + exp(Nu2 + Delta2 .* y + Eta2 .* x0));

		decl evey = meanc(p1 .* y .* V0 + p2 .* y .* V1 + p3 .* y .* V2);
		decl ey = meanc(y);
		decl vary = varc(y);
		decl ev = meanc(p1 .* V0 + p2 .* V1 + p3 .* V2);
		decl ev2 = meanc(p1 .* V0.^2 + p2 .* V1.^2 + p3 .* V2.^2);
		decl varv = ev2 - ev.^2;

		decl teller_rho = evey-ev .* ey;
		decl noemer_rho =  sqrt(vary .* varv);

		decl rho = teller_rho ./ noemer_rho;		
	
		rho_p += rho;
		varv_p += varv;

		if (avScore)
		{
			decl dv0 = meanc(p1);
			decl dv2dv0 = meanc(2 .* p1 .* V0);
			decl dv1 = meanc(p2);
			decl dv2dv1 = meanc(2 .* p2 .* V1);
			decl dv2 = meanc(p3);
			decl dv2dv2 = meanc(2 .* p3 .* V2);			
			decl dnu1 = meanc(p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2);
			decl dv2dnu1 = meanc(p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2);
			decl dnu2 = meanc(-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2);
			decl dv2dnu2 = meanc(-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2);			
			decl ddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl dv2ddelta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* y);
			decl ddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl dv2ddelta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* y);
			decl deta1 =  meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* x0);
			decl dv2deta1 = meanc((p1 .* (1-p1) .* V0.^2 - p1 .* p2 .* V1.^2 - p1 .* p3 .* V2.^2) .* x0);
			decl deta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* x0);
			decl dv2deta2 = meanc((-p1 .* p2 .* V0.^2 + p2 .* (1-p2) .* V1.^2 - p2 .* p3 .* V2.^2) .* x0);			
			decl dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2)) .* Sigma_chi;
			decl dv2dsigma = meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0.^2
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1.^2
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2.^2)) .* Sigma_chi;
			decl dvarvdv0 = dv2dv0 - 2 .* ev .* dv0;
			decl dvarvdv1 = dv2dv1 - 2 .* ev .* dv1;
			decl dvarvdv2 = dv2dv2 - 2 .* ev .* dv2;
			decl dvarvdnu1 = dv2dnu1 - 2 .* ev .* dnu1;
			decl dvarvdnu2 = dv2dnu2 - 2 .* ev .* dnu2;
			decl dvarvddelta1 = dv2ddelta1 - 2 .* ev .* ddelta1;
			decl dvarvddelta2 = dv2ddelta2 - 2 .* ev .* ddelta2;
			decl dvarvdeta1 = dv2deta1 - 2 .* ev .* deta1;
			decl dvarvdeta2 = dv2deta2 - 2 .* ev .* deta2;
			decl dvarvdsigma = dv2dsigma - 2 .* ev .* dsigma;

			decl deveydv0 = meanc(p1 .* y);
			decl deveydv1 = meanc(p2 .* y);
			decl deveydv2 = meanc(p3 .* y);
			decl deveydnu1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y);
			decl deveydnu2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y);
			decl deveyddelta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y.^2);
			decl deveyddelta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y.^2);
			decl deveydeta1 = meanc((p1 .* (1-p1) .* V0 - p1 .* p2 .* V1 - p1 .* p3 .* V2) .* y .* x0);
			decl deveydeta2 = meanc((-p1 .* p2 .* V0 + p2 .* (1-p2) .* V1 - p2 .* p3 .* V2) .* y .* x0);			
			decl deveydsigma =  meanc(((p1 .* (Delta1 - Delta2) .* (1-p1) + p1 .* Delta2 .* p3) .* dy .* V0
									+ (p2 .* (Delta2 - Delta1) .* (1-p2) + p2 .* Delta1 .* p3) .* dy .* V1
									- (Delta1 .* p1 + Delta2 .* p2) .* p3 .* dy .* V2) .* y + p1 .* V0 .* dy + p2 .* V1 .* dy + p3 .* V2 .* dy) .* Sigma_chi;
			decl dtellerdv0 = deveydv0 - ey .* dv0 ; 
			decl dtellerdv1 = deveydv1 - ey .* dv1 ; 
			decl dtellerdv2 = deveydv2 - ey .* dv2 ; 
			decl dtellerdnu1 = deveydnu1 - ey .* dnu1; 
			decl dtellerdnu2 = deveydnu2 - ey .* dnu2; 
			decl dtellerddelta1 = deveyddelta1 - ey .* ddelta1; 
			decl dtellerddelta2 = deveyddelta2 - ey .* ddelta2;
			decl dtellerdeta1 = deveydeta1 - ey .* deta1; 
			decl dtellerdeta2 = deveydeta2 - ey .* deta2; 			
			decl dtellerdsigma = deveydsigma - ey .* dsigma - meanc(dy) .* ev .* Sigma_chi;

			decl dnoemerdv0 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv0 .* vary); 
			decl dnoemerdv1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv1 .* vary); 
			decl dnoemerdv2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdv2 .* vary); 
			decl dnoemerdnu1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu1 .* vary); 
			decl dnoemerdnu2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdnu2 .* vary); 
			decl dnoemerddelta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta1 .* vary); 
			decl dnoemerddelta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvddelta2 .* vary);
			decl dnoemerdeta1 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta1 .* vary); 
			decl dnoemerdeta2 = (1 ./ (2 .* noemer_rho)) .* (dvarvdeta2 .* vary); 			
			decl dnoemerdsigma = (1 ./ (2 .* noemer_rho)) .* (dvarvdsigma .* vary + (2 .* meanc(y .* dy) - 2 .* meanc(y) .* meanc(dy)) .* varv .* Sigma_chi);

			decl drhodv0 = (dtellerdv0 .* noemer_rho - dnoemerdv0 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv1 = (dtellerdv1 .* noemer_rho - dnoemerdv1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodv2 = (dtellerdv2 .* noemer_rho - dnoemerdv2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu1 = (dtellerdnu1 .* noemer_rho - dnoemerdnu1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodnu2 = (dtellerdnu2 .* noemer_rho - dnoemerdnu2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta1 = (dtellerddelta1 .* noemer_rho - dnoemerddelta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhoddelta2 = (dtellerddelta2 .* noemer_rho - dnoemerddelta2 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta1 = (dtellerdeta1 .* noemer_rho - dnoemerdeta1 .* teller_rho) ./ (noemer_rho.^2);
			decl drhodeta2 = (dtellerdeta2 .* noemer_rho - dnoemerdeta2 .* teller_rho) ./ (noemer_rho.^2);;
			decl drhodsigma = (dtellerdsigma .* noemer_rho - dnoemerdsigma .* teller_rho) ./ (noemer_rho.^2);
			
			dvarv_p  += zeros(1,rows(vP)-10)~dvarvdv0~dvarvdv1~dvarvdv2~dvarvdnu1~dvarvdnu2~dvarvddelta1~dvarvddelta2~dvarvdeta1~dvarvdeta2~dvarvdsigma;
			drho_p  += zeros(1,rows(vP)-10)~drhodv0~drhodv1~drhodv2~drhodnu1~drhodnu2~drhoddelta1~drhoddelta2~drhodeta1~drhodeta2~drhodsigma;		
		}
	}

	if (avScore)
	{
		avScore[0] = drho_p ./ P_random;
	}	

	adFunc[0] = (rho_p ./ P_random);	 
	
	return 1;
}

main()
{  
	decl adfunc, avscore;


	MaxControlEps(0.001, 0.001);

	decl model = new ModelChild();	

	if (model.myid .== 0)
		MaxControl(-1,1);
		


	decl vp =         -0.47217 |    -0.31030 |    0.051633 |   0.0017542 |    -0.11410 |   -0.034859  |
     -0.57970 |      3.0107  |    -4.2414   |  -0.22411 |    -0.54752  |   -0.58840	 |
    -0.011596 |    -0.81277  |    0.39061   |   0.95592 |     0.14641  |    0.56663	 |
      0.29099 |    -0.24655  |    0.53265   |  -0.41542 |    -0.89971  |   -0.17134	 |
     -0.37263 |   -0.041542  |  -0.039693   |  0.032584 |    -0.28692  |   -0.66063	 |
     -0.72013 |     -1.0124  |    -1.1350   |   -1.1097 |     -1.6910  |   -0.96183	 |
     -0.17098 |    -0.68991  |  -0.079084   |  -0.66531 |    -0.34073  |   -0.59803	 |
     -0.45938 |    -0.88960  |    -1.6770   |   0.51267 |    -0.41583  |    -1.5649	 |
     -0.76256 |      2.0324  |    -4.5203    |   3.9804 |      1.5031  |    -8.3621	 |
      -5.1430 |      5.1783  |     2.5855    |   2.6264 |   -0.096278;


	decl stderr = model.BerekenStandardErrors(vp);

	if (model.myid == 0)
		println(stderr);
	
	decl model1 = new ModelChild1();

	model1.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model1.myid == 0)
		println(avscore);

	decl model2 = new ModelChild2();

	model2.FLoglik10(vp, &adfunc, &avscore, 0);

	if (model2.myid == 0)
		println(avscore);			

	delete model;	
	delete model1;
	delete model2;
	
	return 1;
}
